import 'package:dcli/dcli.dart';
import 'archiver.dart';

class Rar extends Archiver {
  @override
  final String extension = '.rar';

  @override
  String command(Operation operation) => 'unrar';

  @override
  bool get canCompress => false;

  @override
  bool get canExpand => true;

  @override
  bool isInstalled(Operation operation) =>
      // ignore: avoid_bool_literals_in_conditional_expressions
      operation == Operation.expand ? which(command(operation)).found : false;

  @override
  void compress(
      {required String pathToArchive,
      required String workingDirectory,
      required bool recursive}) {
    throw UnsupportedError(
        '$command(Operation.compress) does not support compression');
  }

  @override
  void expand(
      {required String pathToArchive, required String workingDirectory}) {
    '${command(Operation.expand)} e $pathToArchive'
        .start(workingDirectory: workingDirectory);
  }

  @override
  void expandSingle(
      {required String pathToArchive,
      required String workingDirectory,
      required String pathToSingle,
      bool includePath = false}) {}
}
