import 'package:dcli/dcli.dart';
import 'archiver.dart';

class TarGz extends Archiver {
  @override
  final String extension = '.tar.gz';

  @override
  String command(Operation operation) => 'tar';

  @override
  bool get canCompress => true;

  @override
  bool get canExpand => true;

  @override
  bool isInstalled(Operation operation) => which(command(operation)).found;

  @override
  void compress(
      {required String pathToArchive,
      required String workingDirectory,
      required bool recursive}) {
    '${command(Operation.compress)} -czvf $pathToArchive .'
        .start(workingDirectory: workingDirectory);
  }

  @override
  void expand(
      {required String pathToArchive, required String workingDirectory}) {
    '${command(Operation.expand)} -zxvf $pathToArchive'
        .start(workingDirectory: workingDirectory);
  }

  @override
  void expandSingle(
      {required String pathToArchive,
      required String workingDirectory,
      required String pathToSingle,
      bool includePath = false}) {}
}
