#! /usr/bin/env dcli

import 'package:args/command_runner.dart';
import 'package:dcli/dcli.dart';
import 'archivers/archivers.dart';
import 'commands/compress.dart';
import 'commands/expand.dart';

int entryPoint(List<String> args) {
  final runner = CommandRunner<int>('darchive', '''
Expands and Compresses files to/from an archive file.
The following archive formats are supported:
${Archivers().usageSupported}''')
    ..addCommand(Compress())
    ..addCommand(Expand());

  try {
    return waitForEx(runner.run(args)) ?? 1;
  } on FormatException catch (e) {
    printerr(red(e.message));
    print(runner.usage);
    return -1;
  } on UsageException catch (e) {
    printerr(red(e.message));
    print(runner.usage);
    return -1;
  }
}
